<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Filters StructType
 * @subpackage Structs
 */
class Filters extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Condition
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Condition;
    /**
     * The DataField
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DataField;
    /**
     * The Operator
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Operator;
    /**
     * The OpenBraces
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OpenBraces;
    /**
     * The CloseBraces
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CloseBraces;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Value;
    /**
     * The Value2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Value2;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\FiltersServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for Filters
     * @uses Filters::setDisplayName()
     * @uses Filters::setCondition()
     * @uses Filters::setDataField()
     * @uses Filters::setOperator()
     * @uses Filters::setOpenBraces()
     * @uses Filters::setCloseBraces()
     * @uses Filters::setValue()
     * @uses Filters::setValue2()
     * @uses Filters::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $condition
     * @param \StructType\Field $dataField
     * @param \StructType\Field $operator
     * @param \StructType\Field $openBraces
     * @param \StructType\Field $closeBraces
     * @param \StructType\Field $value
     * @param \StructType\Field $value2
     * @param \StructType\FiltersServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $condition = null, \StructType\Field $dataField = null, \StructType\Field $operator = null, \StructType\Field $openBraces = null, \StructType\Field $closeBraces = null, \StructType\Field $value = null, \StructType\Field $value2 = null, \StructType\FiltersServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setCondition($condition)
            ->setDataField($dataField)
            ->setOperator($operator)
            ->setOpenBraces($openBraces)
            ->setCloseBraces($closeBraces)
            ->setValue($value)
            ->setValue2($value2)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\Filters
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Condition value
     * @return \StructType\Field|null
     */
    public function getCondition()
    {
        return $this->Condition;
    }
    /**
     * Set Condition value
     * @param \StructType\Field $condition
     * @return \StructType\Filters
     */
    public function setCondition(\StructType\Field $condition = null)
    {
        $this->Condition = $condition;
        return $this;
    }
    /**
     * Get DataField value
     * @return \StructType\Field|null
     */
    public function getDataField()
    {
        return $this->DataField;
    }
    /**
     * Set DataField value
     * @param \StructType\Field $dataField
     * @return \StructType\Filters
     */
    public function setDataField(\StructType\Field $dataField = null)
    {
        $this->DataField = $dataField;
        return $this;
    }
    /**
     * Get Operator value
     * @return \StructType\Field|null
     */
    public function getOperator()
    {
        return $this->Operator;
    }
    /**
     * Set Operator value
     * @param \StructType\Field $operator
     * @return \StructType\Filters
     */
    public function setOperator(\StructType\Field $operator = null)
    {
        $this->Operator = $operator;
        return $this;
    }
    /**
     * Get OpenBraces value
     * @return \StructType\Field|null
     */
    public function getOpenBraces()
    {
        return $this->OpenBraces;
    }
    /**
     * Set OpenBraces value
     * @param \StructType\Field $openBraces
     * @return \StructType\Filters
     */
    public function setOpenBraces(\StructType\Field $openBraces = null)
    {
        $this->OpenBraces = $openBraces;
        return $this;
    }
    /**
     * Get CloseBraces value
     * @return \StructType\Field|null
     */
    public function getCloseBraces()
    {
        return $this->CloseBraces;
    }
    /**
     * Set CloseBraces value
     * @param \StructType\Field $closeBraces
     * @return \StructType\Filters
     */
    public function setCloseBraces(\StructType\Field $closeBraces = null)
    {
        $this->CloseBraces = $closeBraces;
        return $this;
    }
    /**
     * Get Value value
     * @return \StructType\Field|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param \StructType\Field $value
     * @return \StructType\Filters
     */
    public function setValue(\StructType\Field $value = null)
    {
        $this->Value = $value;
        return $this;
    }
    /**
     * Get Value2 value
     * @return \StructType\Field|null
     */
    public function getValue2()
    {
        return $this->Value2;
    }
    /**
     * Set Value2 value
     * @param \StructType\Field $value2
     * @return \StructType\Filters
     */
    public function setValue2(\StructType\Field $value2 = null)
    {
        $this->Value2 = $value2;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\FiltersServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\FiltersServiceCommands $serviceCommands
     * @return \StructType\Filters
     */
    public function setServiceCommands(\StructType\FiltersServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
